stages:
  - build

build-container:
  stage: build
  image: alpine:3.14.2
  services:
    - docker:stable-dind
  variables:
    DOCKER_HOST: tcp://docker:2375
  before_script:
    - apk add --update --no-cache curl docker-cli
    - mkdir -p "${HOME}/.docker/cli-plugins/"
    - curl -sLo "${HOME}/.docker/cli-plugins/docker-buildx" https://github.com/docker/buildx/releases/download/v0.6.3/buildx-v0.6.3.linux-amd64
    - chmod a+x "${HOME}/.docker/cli-plugins/docker-buildx"
    - docker buildx install
  script:
    - export IMAGE_BASE=$CI_REGISTRY_IMAGE
    - export IMAGE_CACHE_TAG=$CI_COMMIT_REF_NAME
    - echo $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER $CI_REGISTRY --password-stdin
    - docker buildx create --use
    - docker buildx build
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      --tag $IMAGE_BASE:$IMAGE_CACHE_TAG
      --cache-from=type=registry,ref=$IMAGE_BASE:$IMAGE_CACHE_TAG
      --cache-to=type=registry,ref=$IMAGE_BASE:$IMAGE_CACHE_TAG
      --push
      .
